public class Examples {
  
  // sample ImageFile data to be used for all tests
  public ImageFile pic1 = new ImageFile("dog", 100, 200, "jpg");
  public ImageFile pic2 = new ImageFile("cat", 200, 200, "png");
  public ImageFile pic3 = new ImageFile("bird", 250, 200, "jpg");
  public ImageFile pic4 = new ImageFile("horse", 300, 300, "giff");
  public ImageFile pic5 = new ImageFile("goat", 100, 200, "giff");
  public ImageFile pic6 = new ImageFile("cow", 150, 200, "jpg");
  public ImageFile pic7 = new ImageFile("snake", 200, 300, "jpg");
  
  // rest all ImageFile data to the original values before running a test
  public void resetImageFileData(){
    this.pic1 = new ImageFile("dog", 300, 200, "jpg");
    this.pic2 = new ImageFile("cat", 200, 200, "png");
    this.pic3 = new ImageFile("bird", 250, 200, "jpg");
    this.pic4 = new ImageFile("horse", 300, 300, "giff");
    this.pic5 = new ImageFile("goat", 100, 200, "giff");
    this.pic6 = new ImageFile("cow", 150, 200, "jpg");
    this.pic7 = new ImageFile("snake", 200, 300, "jpg");
  }
  
  // sample LoIF data to be used for all tests
  public LoIF mtlist = new MtLoIF();
  public LoIF list1 = new ConsLoIF(this.pic1, this.mtlist);
  public LoIF listall = new ConsLoIF(this.pic2, 
      new ConsLoIF(this.pic3,  
          new ConsLoIF(this.pic4,  
              new ConsLoIF(this.pic5,  
                  new ConsLoIF(this.pic6,  
                      new ConsLoIF(this.pic7, this.mtlist))))));
  
  // sample classes that implement ISelect
  class SmallerThan40000 implements ISelect {
    public boolean select(ImageFile imf){
      if (imf.width * imf.height < 40000)
        return true;
      else
        return false;
    }
  }
  
  public SmallerThan40000 smallerThan40000 = new SmallerThan40000();
  
  // sample classes that implement ISelect
  class NameShorterThan4 implements ISelect {
    public boolean select(ImageFile imf){
      if (imf.name.length() < 4)
        return true;
      else
        return false;
    }
  }

  public NameShorterThan4 nameShorterThan4 = new NameShorterThan4(); 
  
  
  // the test harness for all tests
  public TestHarness th = new TestHarness("Test ImageFile methods ");
  
  // run the test suite for the crop method 
  public void testCropMethod() {
    // SETUP (for both tests)
    this.resetImageFileData();
    
    // APPLY THE METHOD
    pic1.crop(100, 100);

    // TEST THE EFFECT
    th.test("crop1: ", pic1, new ImageFile("dog", 100, 100, "jpg"));
    
    // APPLY THE METHOD
    pic2.crop(100, 100);

    // TEST THE EFFECT
    th.test("crop2: ", pic2, new ImageFile("cat", 100, 100, "png"));
  }
  
  // run the test suite for the changeName method 
  public void testChangeNameMethod() {
    // SETUP (for both tests)
    this.resetImageFileData();
    
    // APPLY THE METHOD
    pic1.changeName("mutt");

    // TEST THE EFFECT
    th.test("changeName1: ", pic1, new ImageFile("mutt", 300, 200, "jpg"));
    
    // APPLY THE METHOD
    pic2.changeName("boots");

    // TEST THE EFFECT
    th.test("changeName2: ", pic2, new ImageFile("boots", 200, 200, "png"));
  }
  
  // run the test suite for the allSuch method 
  public void testAllSuchMethod() {
    // SETUP (for both tests)
    this.resetImageFileData();
    
    /*
    th.test("allSuch1: ", mtlist.allSuch(???), ???);
    th.test("allSuch2: ", ???, ???);
    th.test("allSuch3: ", ???, ???);
    */
  }
  
 // hook to the outside world
  public static void main(String argv[]){
    Examples e = new Examples();
    
    // show the data used in the tests
    // ... included only for illustration --- not needed
    System.out.println("" + e.pic1);
    System.out.println("" + e.pic2);
    
    System.out.println("" + e.mtlist);
    System.out.println("" + e.list1);
    System.out.println("" + e.listall);

    //run all tests;
    e.testCropMethod();
    e.testChangeNameMethod();
    e.testAllSuchMethod();
    
    // report the test results
    e.th.testReport();
    e.th.fullTestReport();
  }
  

}